#ifndef _soundbuffer
#define _soundbuffer

#include "defsize.h"
#include "scrollclass.h"
#include "parameter.h"

const int bufferNum=4;
#define reverbsizemax def_buffersize
_extern short back[reverbsizemax];

_extern double reverbbuffer[reverbsizemax];
_extern PBYTE pReadBuffer,pBuffer[bufferNum], pSaveBuffer, pNewBuffer, pSkipBuffer ;

_extern scrl npos,wavL,wavR;

const ULONG readbuffersizemin =512;
_extern ULONG readbuffersizemax;
_extern ULONG membuffersize;
_extern float membufferrate;
_extern ULONG oldbuffersize;
_extern ULONG levelchecksize;
_extern ULONG readbuffersize;
_extern ULONG readspeedsize;
_extern ULONG outbuffersize;//1
_extern ULONG editoffset;
_extern long nextzero;
#define waveshotdefault 12
#define skipleveldefault 1
#define skiplevelmax 100
#define def_picskip 80
//_extern ULONG picskip;

void initBuffer();
parameter *getpicskip();
void initpicskip();
void loadbuff(PBYTE &pSaveBuffer,DWORD datasize,char *buffname);
void buffreset();
BOOL zerocheck(PBYTE &pSkipBuffer,int rep);
BOOL errorcheck(HWND hwnd,PBYTE *pBuffer);
void setreadbuffersize();
void initReadBuffer(PBYTE &);
void resetmembuffersize();
void upmembuffersize();
void setmembuffersize();
void downmembuffersize();
void readallsoundpic(PBYTE &buffer, char *filename, ULONG step=30, ULONG size=1000);
ULONG datapos();
void OpenRecBuffer(ofstream &ou);

void nextbuff(ofstream &ou, ULONG buffnum);


#endif _soundbuffer