
//---------------------------------------------------------
//	dialog 

#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>

#include "resource.h"
#include "tabasa_recorder.h"
#include "SubSoundPlayDlg.h"

const char DlgTitle[]="sub sound";
static int mode;
#define _PLAY 0
#define _STOP 1
#define _OPEN 2
int modemax=2;
char initmark[]="";


BOOL CALLBACK SubSoundPlayProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static int nownum,n;
	WORD num;
     switch (message)
     {
		case WM_INITDIALOG:
			SetWindowText(hwnd,DlgTitle);
			mode=_OPEN;
			for(n=0;n<effectfilemax;n++)
			{
				if(ef[n].getloaded())SetDlgItemInt(hwnd,IDC_SUB_PLAY_1 + n, n+1 , FALSE);
				else SetDlgItemText(hwnd,IDC_SUB_PLAY_1 + n, initmark );
			}
			break;

     case WM_COMMAND:
		 if(LOWORD (wParam)>=IDC_SUB_PLAY_1 && LOWORD (wParam)<=IDC_SUB_PLAY_1 + effectfilemax )

		 {
			 num=LOWORD (wParam) -IDC_SUB_PLAY_1;
			 switch(mode)
			 {
			 case _PLAY:
				SendMessage (mainhwnd, WM_COMMAND, IDC_SUB_PLAY,num) ;
				break;

			 case _STOP:
				SendMessage (mainhwnd, WM_COMMAND, IDC_SUB_STOP,num) ;
				break;

			 case _OPEN:
				SendMessage (mainhwnd, WM_COMMAND, IDC_SUB_OPEN,num) ;
				SetDlgItemInt(hwnd,LOWORD (wParam) ,LOWORD (wParam)-IDC_SUB_PLAY_1 +1 ,FALSE);
				break;
			 }
		 }
          switch (LOWORD (wParam))
          {
		  case IDC_PLAY_BEG://main sound 
			  switch(mode)
			  {
			  case _PLAY:
				SendMessage (mainhwnd, WM_COMMAND, wParam,0) ;
				break;

			  case _STOP:
				SendMessage (mainhwnd, WM_COMMAND, IDC_PLAY_END,0) ;
				break;

			  case _OPEN:
				SendMessage (mainhwnd, WM_COMMAND, IDC_FILE_LOAD,0) ;
				break;
			  }
			  break;

			case IDC_SUB_ALL_STOP:
				StopAllSubSound();
				break;

		  case IDC_MODE_CHANGE://main sound 
				mode+=1;
				if(mode>modemax) mode=0;
				switch(mode)
				{
				case _PLAY:
					SetDlgItemText(hwnd,IDC_MODE_CHANGE,"play");
					SetDlgItemText(hwnd,IDC_PLAY_BEG,">");
					break;

				case _STOP:
					SetDlgItemText(hwnd,IDC_MODE_CHANGE,"stop");
					SetDlgItemText(hwnd,IDC_PLAY_BEG,"0");
					break;

				case _OPEN:
					SetDlgItemText(hwnd,IDC_MODE_CHANGE,"open");
					SetDlgItemText(hwnd,IDC_PLAY_BEG,"open");
					break;
				}
				break;

          case IDOK:
          case IDCANCEL:
               SendMessage (hwnd, WM_SYSCOMMAND, SC_CLOSE, 0L) ;
               return TRUE ;


		  }
		  break;

		case WM_SYSCOMMAND:
			switch (LOWORD (wParam))
			{
				case SC_CLOSE:
					EndDialog (hwnd, 0) ;
				return TRUE ;
			}
			break ;
          
	}
	 return FALSE;
}
