
#include "defextern.h"

#include <stdio.h>
//#include <iostream.h>
//#include <fstream.h>
#include <windows.h>
#include "resource.h"
#include "tabasa_recorder.h"
#include "scroll.h"
#include "wav8bit.h"
#include "SoundBuffer.h"
#include "WaveEditOnPlaying.h"

#define _FROM 0
#define _TO 1
#define _LEFT 0
#define _RIGHT 1

#define _NOW 0
#define _LAST 1

#define between(n,ni,m,mi) ((n*ni+m*mi)/(ni+mi))




//............................................
//	炩ɂȂAt@Co

void tsunagu(ofstream &ou,short lstart,short rstart,short lend,short rend,long noiseofflen)
{
	long lsa,rsa,i;
	short zerodata=0,ldata,rdata;
	lsa=lend-lstart;
	rsa=rend-rstart;
	for(i=0;i<noiseofflen/2/2;i++)
	{
		ldata=lstart+(double)lsa*i/(noiseofflen/4);
		rdata=rstart+(double)rsa*i/(noiseofflen/4);
		ou.write((char*)&ldata,2);
		ou.write((char*)&rdata,2);
	}
}


//............................................
//	炩ɂȂAobt@o

void tsunagu(PBYTE &buffer,short lstart,short rstart,short lend,short rend,long noiseofflen)
{
	long lsa,rsa,i;
	short zerodata=0,ldata,rdata;
	lsa=lend-lstart;
	rsa=rend-rstart;
	for(i=0;i<noiseofflen/2/2;i++)
	{
		ldata=lstart+(double)lsa*i/(noiseofflen/4);
		rdata=rstart+(double)rsa*i/(noiseofflen/4);
		*(buffer+0+i*4) = *((char*)&ldata);
		*(buffer+1+i*4) = *(((char*)&ldata)+1);
		*(buffer+2+i*4) = *((char*)&rdata);
		*(buffer+3+i*4) = *(((char*)&rdata)+1);
	}
}

void WaveEditOnPlayingInit()
{
	reverblevel=0.67;
	reverbrate=0.55;
	noiseofflenreset();
}

void minimumlenInit()
{
	editminimumlen.setdefdata(editminimumlen_0);
	editminimumlen.reset();
	editminimumlen.setstep(8);
	editminimumlen.setmin(16);
}

void noiseofflenreset()
{
	noiseofflen=0;//8 *4
}

void noiseofflenup()
{
	noiseofflen +=4;
}

void noiseofflendown()
{
	if(noiseofflen>=4)noiseofflen -=4;
}

void setpan(float pan,float lastpan,float *leftleft,float *leftright,float *rightright,float *rightleft)
{
	if(pan>0) 
	{
		rightright[_NOW]=1;
		rightleft[_NOW]=-pan/100;
		leftright[_NOW]=0;
		leftleft[_NOW]=1-rightleft[_NOW];
	}
	else 
	{
		leftleft[_NOW]=1;
		leftright[_NOW]=pan/100;
		rightleft[_NOW]=0;
		rightright[_NOW] =1-leftright[_NOW];
	}
	if(lastpan>0) 
	{
		rightright[_LAST]=1;
		rightleft[_LAST]=-lastpan/100;
		leftright[_LAST]=0;
		leftleft[_LAST]=1-rightleft[_LAST];
	}
	else 
	{
		leftleft[_LAST]=1;
		leftright[_LAST]=lastpan/100;
		rightleft[_LAST]=0;
		rightright[_LAST] =1-leftright[_LAST];
	}
}

BOOL EffectPlusMemory(PBYTE &pBuffer, PBYTE &pEffectBuffer,unsigned long size,unsigned long effectsize,float boost,float &lastboost,float pan,float &lastpan)
{
	BOOL flag=TRUE;
	float leftleft[2],leftright[2],rightright[2],rightleft[2];
	setpan(pan,lastpan,leftleft,leftright,rightright,rightleft);
	if (samplesize==16)
	{
			short* pB16=(short*)pBuffer;
			short* pB=(short*)pEffectBuffer;
			short data[2][2],data0[2];
			unsigned long i ,j;
			for (i = 0 ; i < effectsize/2 ; i+=2)
			{
				j =effectsize/2 -i;
				data[_LEFT][_FROM]=pB[i+_LEFT];
				data[_LEFT][_TO]=pB16[i+_LEFT];
				data[_RIGHT][_FROM]=pB[i+_RIGHT];
				data[_RIGHT][_TO]=pB16[i+_RIGHT];
				/*
				pB16[i+_LEFT] =checkoverflow16bit(data[_LEFT][_FROM]+data[_LEFT][_TO]*boost);
				pB16[i+_RIGHT] =checkoverflow16bit(data[_RIGHT][_FROM]+data[_RIGHT][_TO]*boost);*/
				//Tuboost
				data0[_LEFT]=checkoverflow16bit(data[_LEFT][_FROM]*boost);
				data0[_RIGHT]=checkoverflow16bit(data[_RIGHT][_FROM]*boost);
				//TupɂāACɉ
				if(addmode==_ADD)
				{
					pB16[i+_LEFT]=checkoverflow16bit( data[_LEFT][_TO] +data0[_LEFT]*between(leftleft[_NOW],i ,leftleft[_LAST],j) + data0[_RIGHT]*between(leftright[_NOW],i,leftright[_LAST],j) );
					pB16[i+_RIGHT]=checkoverflow16bit( data[_RIGHT][_TO] +data0[_LEFT]*between(rightleft[_NOW],i,rightleft[_LAST],j) + data0[_RIGHT]*between(rightright[_NOW],i,rightright[_LAST],j) );
				}
				//TuACɊ|
				
				else
				{
					pB16[i+_LEFT]=checkoverflow16bit( data[_LEFT][_TO] *data0[_LEFT]/bit16max);
					pB16[i+_RIGHT]=checkoverflow16bit( data[_RIGHT][_TO] *data0[_LEFT]/bit16max);
				}
				/**/
				//if((short)(data+data2*boost) != pB16[i])flag=FALSE;//overflow

			}
	}
	else if (samplesize==8)
	{
		/*
			PBYTE pB16=(PBYTE)pBuffer;
			PBYTE pB=(PBYTE)pBuffer;
			BYTE data;
			int i ;
			for (i = 0 ; i < iLength ; i++)
			{
				data=pB16[i];
				pB16[i] =checkoverflow8bit(times8bit(pB16[i],level));
				if((long)(data*level) != (long)(pB16[i]))flag=FALSE;//overflow

			}
*/
	}
	else return flag;

	lastpan=pan;
	return flag;
}

BOOL LevelMemory (PBYTE &pBuffer, int iLength, float level,WaveTrack &w)
{
	BOOL flag=TRUE;
	float leftleft[2],leftright[2],rightright[2],rightleft[2];
	setpan(w.getPan(),w.getlastPan(),leftleft,leftright,rightright,rightleft);
	w.setPan(w.getPan());
	if (samplesize==16)
	{
			short* pB16=(short*)pBuffer;
			short* pB=(short*)pBuffer;
			short data[2];
			int i ,j;
			for (i = 0 ; i < iLength/2 ; i+=2)
			{
				j=iLength/2 -i;
				data[_LEFT]=pB16[i];
				data[_RIGHT]=pB16[i+1];
				pB16[i] =checkoverflow16bit((data[_LEFT]*between(leftleft[_NOW],i ,leftleft[_LAST],j) + data[_RIGHT]*between(leftright[_NOW],i,leftright[_LAST],j))*level);
				pB16[i+1] =checkoverflow16bit((data[_LEFT]*between(rightleft[_NOW],i,rightleft[_LAST],j) + data[_RIGHT]*between(rightright[_NOW],i,rightright[_LAST],j))*level);
				//if((short)(data[]*level) != pB16[i])flag=FALSE;//overflow

			}
	}
	else if (samplesize==8)
	{
			PBYTE pB16=(PBYTE)pBuffer;
			PBYTE pB=(PBYTE)pBuffer;
			BYTE data;
			int i ;
			for (i = 0 ; i < iLength ; i++)
			{
				data=pB16[i];
				pB16[i] =checkoverflow8bit(times8bit(pB16[i],level));
				if((long)(data*level) != (long)(pB16[i]))flag=FALSE;//overflow

			}

	}
	else return flag;

	return flag;
}


//---------------------------------------------------------
//	o[ut
//	ꎞobt@reverbbuffer[] ɍ쐬ĂAŌɌ̃obt@ɃRs[A
//	obt@܂镔̓obNAbv back[]@ɕۑ@(t@CЂƂJقyH)@
//	

void adReverbMemory (PBYTE &pBuffer, int iLength, int reverbsize)
{
	if (samplesize==16)
	{
		if(iLength/2 <reverbsize)reverbsize=iLength/2;

		short* pB16=(short*)pBuffer;
		short* pB=(short*)pBuffer;
		double* pRev=reverbbuffer;
		int  i ;
	//ꎞobt@ł̏
		//obt@܂鏈
		for (i = 0 ; i <reverbsize; i++)
		{
			reverbbuffer [i] =pB16[i]+back[i]*reverbrate;
		}
		if(feedbackflag)
			{
			//݂̃obt@
			for (i = 0 ; i < iLength/2 -reverbsize; i++)
			{
				reverbbuffer [i+reverbsize] =pRev[i]*reverbrate+pB16[i+reverbsize];
			}
			//o[upobNAbvobt@XVAĩ݂obt@̍Ō̕o[uTCYj
			for(i = 0 ; i < reverbsize ; i++,pRev++)
			{
				back[i]=checkoverflow16bit(pRev[max(0,iLength/2-reverbsize-1)]);
			}

		}
		else
		{
			//݂̃obt@
			for (i = 0 ; i < iLength/2 -reverbsize; i++)
			{
				reverbbuffer [i+reverbsize] =pB[i]*reverbrate+pB16[i+reverbsize];
			}
			//o[upobNAbvobt@XVAĩ݂obt@̍Ō̕o[uTCYj
			for(i = 0 ; i < reverbsize ; i++,pB++)
			{
				back[i]=pB[max(0,iLength/2-reverbsize-1)];
			}

		}
	//̃obt@ɃRs[
		for (i = 0 ; i < iLength/2 ; i++)
		{
			pB16[i] =checkoverflow16bit(reverbbuffer [i]*level*reverblevel);
		}

	}
	else if (samplesize==8)
	{
		if(iLength <reverbsize)reverbsize=iLength;

		PBYTE pB16=(PBYTE)pBuffer;
		PBYTE pB=(PBYTE)pBuffer;
		wav8bit wav1,wav2;//wav8bit clasśi=,+,*jgiBYTEɂāj>wav8bit.h
		int  i ; 
		for (i = 0 ; i < iLength -reverbsize; i++)
		{
			wav1=pB16[i];
			wav2=pB16[i+reverbsize];
			((PBYTE)reverbbuffer) [i+reverbsize] =wav1*reverbrate+wav2;
		}
		for (i = 0 ; i <reverbsize; i++)
		{
			wav1=back[i];
			wav2=pB16[i];
			((PBYTE)reverbbuffer) [i] =wav2+wav1*reverbrate;
		}
		for(i = 0 ; i < reverbsize ; i++,pB++)back[i]=pB[max(0,iLength-reverbsize-1)];

		for (i = 0 ; i < iLength ; i++)
		{
			wav1=((PBYTE)reverbbuffer) [i];
			pB16[i] =wav1*level*reverblevel;
		}

	}
}


void ReverseMemory (PBYTE &pBuffer, int iLength)
{
     BYTE b ;
     int  i ;
     
     for (i = 0 ; i < iLength / 2 ; i+=2)
     {
          b = pBuffer [i] ;
          pBuffer [i] = pBuffer [iLength - i - 2] ;
          pBuffer [iLength - i - 2] = b ;
          b = pBuffer [i+1] ;
          pBuffer [i+1] = pBuffer [iLength - i - 1] ;
          pBuffer [iLength - i - 1] = b ;
     }
}

//..............................................
//	Đx
//	
//	Ƃ΃sb`ςXs[h{ɒxƂA
//	̒̃f[^ŌJԂB
//	̒Zƃsb`IN^[uAƃGR[̂悤ɕ̂ŁÅԂɂB
//	minimumlen@Œ߂悤ƂĂB
//
//	ZZƂ
//	ƒ
//
//	...ƌ


void changebyspeed(PBYTE &pReadBuffer,PBYTE &pBuffer,float speed,float pitch,unsigned long readmax,unsigned long outsize)
{
	short lstart,rstart,lend,rend;
	unsigned long i,iread,j,jpitch,jpitchflag,k;
	PBYTE pbuffercopy,pMidReadBuffer,pMidBuffer;
	ULONG editlen=editminimumlen.getdata();


	if(!pitchflag ) //tape ̂悤ɑ|| samplesize!=16
	{
		for(i=0; i<outsize; i+=waveshot )
		{
			iread=((unsigned long)(i*speed/waveshot))*waveshot;
			for(j=0; j<waveshot; j++)
				*(pBuffer+i+j) =*(pReadBuffer+iread+j);
		}
	}
	else if( readmax>= editlen*2 && outsize>= editlen*2 )
	{
		pMidReadBuffer =pReadBuffer +readmax/2/waveshot*waveshot;
		pMidBuffer =pBuffer +outsize/2/waveshot*waveshot;
		changebyspeed( pReadBuffer, pBuffer, speed, pitch, readmax/2/waveshot*waveshot, outsize/2/waveshot*waveshot);
		changebyspeed( pMidReadBuffer, pMidBuffer, speed, pitch, readmax-readmax/2/waveshot*waveshot, outsize-outsize/2/waveshot*waveshot);
	}
	else //pitch Œ胂[h
	{
		i=0;
		while(i<outsize)
		for(j=0;j<readmax;j+=waveshot,i+=waveshot) //ǂݍ݁A݁@̃|C^i߂
		{
			if(i<outsize)
			{
				//if(j>=readmax) j=0;
				jpitch=((unsigned long)((float)j*pitch/waveshot))*waveshot;//
				if(jpitch>=readmax-noiseofflen ) 
				{
					j=0;
					jpitch=0;
					for(k=0;k<waveshot;k++)
					{
						*(pBuffer+i+k)=*(pReadBuffer+jpitch+k);
					}
					 //炩Aobt@ԓ
					lend=*(short*)(pReadBuffer);
					rend=*(short*)(pReadBuffer+2);
					lstart=*(short*)(pBuffer+i-noiseofflen);
					rstart=*(short*)(pBuffer+i-noiseofflen+2);
					pbuffercopy =pBuffer+i-noiseofflen;
					tsunagu(pbuffercopy,lstart,rstart,lend,rend,noiseofflen);
				}
				else
				{
					for(k=0;k<waveshot;k++)
					{
						*(pBuffer+i+k)=*(pReadBuffer+jpitch+k);
					}
				}

				if(i>=outsize-noiseofflen)
				//炩Aobt@Ȃڂ̂
				{
					lend=*(short*)(pReadBuffer+readmax-4);
					rend=*(short*)(pReadBuffer+readmax-2);
				//	lstart=*(short*)(pReadBuffer+jpitch);
				//	rstart=*(short*)(pReadBuffer+jpitch+2);
					lstart=*(short*)(pBuffer+i);
					rstart=*(short*)(pBuffer+i+2);
					pbuffercopy =pBuffer+outsize-noiseofflen;
					tsunagu(pbuffercopy,lstart,rstart,lend,rend,noiseofflen);
					i=outsize;
				//break;
				}
			}
			else break;
		}
	}

}