
//---------------------------------------------------------
//	dialog 

#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>

#include "resource.h"
#include "tabasa_recorder.h"
#include "waveeditDlg.h"
#include "wavebit.h"
#include "SoundBuffer.h"
#include "wavepic.h"
#include "wavetrack.h"

#include "error.h"

#include "scroll.h"
#include "scrollclass.h"

#define SubTime( t,d ) 	settexttime(hwnd,IDC_SUB_time,(t),(d))	
const char DlgTitle[]="wave micro edit";
HWND hwndedit,hwndpos=NULL;

#ifdef _debug
error er;
#endif


/*
static int mode;
#define _PLAY 0
#define _STOP 1
#define _OPEN 2
int modemax=2;
*/


void write(PBYTE buffer, ULONG offset)
{
	ofstream out(w.getName(),ios::binary | ios::ate );
	out.seekp(headersize+positionnow+offset*4,ios::beg);//16bit
	out.write((char *)((short*)buffer+offset*2),4);//16rbgAXeI1Zbg
}

void showpos()
{
	char buff[10];
	wsprintf(buff,"%d",positionnow);
	if(hwndpos!=NULL) SetDlgItemText(hwndpos,IDC_EDIT_WAVE_POS,buff);
}

BOOL CALLBACK WaveEditProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static long nownum,n;
//	static POINT subsoundpanp={subsoundvolumep.x,subsoundvolumep.y+70};
	char buff[10];
	static float level;
	static long value=bit16max;
	static PBYTE nowbuffer,nowbufferwrite;
	//static scrl *npos,*wav;

	/*	*/
	WORD num;
     switch (message)
     {
		case WM_INITDIALOG:
			//SubSoundSettingHwnd=hwnd;
			hwndpos=hwnd;
			SetWindowText(hwnd,DlgTitle);
			nownum=30;
			npos.init(hwnd,15,15);
			npos.setvalue(editoffset);
			wavL.init(hwnd,bit16max,bit16min,15,50);
			wavR.init(hwnd,bit16max,bit16min,15,85);

#ifdef _debug
			er.show(wav.getvalue());
#endif
			/*
			editscrollinit(hwnd,hwndedit,edit,value);
			editscrollinit(hwnd,hwndpos,pos,value);
			*/
			//mode=_PLAY;
			break;

     case WM_HSCROLL :
		if((HWND) lParam==wavL.getscrlhwnd())
		{
			wavL.scrollfnc( wParam);
		}
		if((HWND) lParam==wavR.getscrlhwnd())
		{
			wavR.scrollfnc( wParam);
		}
		if((HWND) lParam==npos.getscrlhwnd())
		{
			npos.scrollfnc( wParam);
			editoffset = npos.getvalue();
			wavL.setvalue(*((short*)pWavepicBuffer +editoffset*2));
			wavR.setvalue(*((short*)pWavepicBuffer +editoffset*2 +1));
			w.in.seekg(positionnow +datapos(),ios::beg);
			w.in.read(pSkipBuffer,membuffersize);//g`\pɓǂݍ
			w.in.seekg(positionnow +datapos(),ios::beg);
			showpos();
			ShowWave();
		}
		break;

     case WM_COMMAND:
          switch (LOWORD (wParam))
          {

          case IDOK:
			  *((short*)pWavepicBuffer +editoffset*2) = wavL.getvalue();
			  *((short*)pWavepicBuffer +editoffset*2 +1) = wavR.getvalue();
			  write(pWavepicBuffer,editoffset);
			  break;

          case IDCANCEL:
               SendMessage (hwnd, WM_SYSCOMMAND, SC_CLOSE, 0L) ;
               return TRUE ;


		  }
		  break;

		case WM_SYSCOMMAND:
			switch (LOWORD (wParam))
			{
				case SC_CLOSE:
					EndDialog (hwnd, 0) ;
					WaveEditHwnd=NULL;
					hwndpos=NULL;
				return TRUE ;
			}
			break ;
          
	}
	 return FALSE;
}
