#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include "init.h"
#include "resource.h"
//#include "file.h"
#include "tabasa_recorder.h"
#include "wav8bit.h"
#include "wavepic.h"
#include "waveform.h"
//#include "fileeditDlg.h"
#include "scroll.h"
//#include "WaveEditOnPlaying.h"
//#include "FileSave.h"
#include "SoundBuffer.h"
#include "MainDlg.h"


static char titleform[]="%s..%s";
static char glaf[51]="----+----+----+----+----+----+----+----+----+---**";
static char glaf0[51]="                                                 _";

void MainWinBitButton(BOOL flag)
{
	MainWinButton( IDC_BIT8, flag) ;
	MainWinButton( IDC_BIT16, flag) ;
	MainWinButton( IDC_BIT24, flag) ;
}

void	recordresetbutton(HWND	hwnd)
{
			MainWinBitButton(TRUE);
			MainWinButton( IDC_PLAY_BEG,   FALSE) ;
			MainWinButton( IDC_PLAY_PAUSE, FALSE)  ;
			MainWinButton( IDC_PLAY_END,   FALSE)  ;
			MainWinButton( IDC_PLAY_REP,   FALSE) ;
}

void title(HWND hwnd,char *filename,char *thisname)
{
	char title[MAX_PATH];

	sprintf(title,titleform,filename,thisname);
	SetWindowText(hwnd,title);

}

void showGlaf(char *wavenow,PBYTE pBuffer)
{
				if(samplesize==16)
					sprintf(wavenow,"%d",*((short*)pBuffer));
				else
					sprintf(wavenow,"%d",(*((BYTE*)pBuffer))-bit8mid);
				setvolume100((char*)wavenow);
				setglaf(wavenow);
				Comment(wavenow);
}

void setFileName(HWND hwnd, char* filename, char* pathname)
{

	strcpy(filename,pathname);
	title(hwnd,::filename,thisname);
}


void SetBitButton(HWND hwnd,BOOL flag)
{
	MainWinButton( IDC_BIT8, flag) ;
	MainWinButton( IDC_BIT16, flag) ;
	MainWinButton( IDC_BIT24, flag) ;
}

void LockBitButton(HWND hwnd)
{
	SetBitButton(hwnd,FALSE) ;
}

void setBottunPlayMode()
{
	SetBitButton(mainhwnd, TRUE) ;

	MainWinButton( IDC_PLAY_BEG,   TRUE)  ;
	MainWinButton( IDC_PLAY_PAUSE, FALSE) ;
	MainWinButton( IDC_PLAY_END,   FALSE) ;
	MainWinButton( IDC_PLAY_REP,   TRUE)  ;
	MainWinButton( IDC_PLAY_REV,   TRUE)  ;
	SetFocus (GetDlgItem (mainhwnd, IDC_PLAY_BEG)) ;
	
	Comment("loaded");
	bPlaying =FALSE;
}


void loaderror()
{
	MessageBeep (MB_ICONEXCLAMATION) ;
	MessageBox (mainhwnd, szLoadError, szAppName,
             MB_ICONEXCLAMATION | MB_OK) ;
	Comment("stop");
}

void SetNotRecordingModeButton(HWND hwnd)
{
	MainWinButton( IDC_RECORD_BEG, TRUE) ;
	MainWinButton( IDC_RECORD_END, FALSE) ;
	MainWinButton( IDC_FILE_NAME, TRUE) ;
    SetFocus (GetDlgItem (hwnd, IDC_RECORD_BEG)) ;
}

void SetNotPlayingModeButton(HWND hwnd)
{
	MainWinButton( IDC_BUFF_DOWN, TRUE) ;
	MainWinButton( IDC_BUFF_1, TRUE) ;
	MainWinButton( IDC_BUFF_UP, TRUE) ;
	MainWinButton( IDC_RECORD_BEG, TRUE)  ;
	MainWinButton( IDC_RECORD_END, FALSE)  ;
	MainWinButton( IDC_PLAY_BEG,   TRUE)  ;
	MainWinButton( IDC_PLAY_PAUSE, FALSE) ;
	MainWinButton( IDC_PLAY_END,   FALSE) ;
	MainWinButton( IDC_PLAY_REV,   TRUE)  ;
	MainWinButton( IDC_PLAY_REP,   TRUE)  ;
	SetFocus (GetDlgItem (hwnd, IDC_PLAY_BEG)) ;
	bPlaying =FALSE;
}

void SetRecordedModeButton(HWND hwnd)
{
	MainWinButton( IDC_PLAY_BEG,   TRUE)  ;
	MainWinButton( IDC_PLAY_PAUSE, FALSE) ;
	MainWinButton( IDC_PLAY_END,   FALSE) ;
	MainWinButton( IDC_PLAY_REP,   TRUE)  ;
	MainWinButton( IDC_PLAY_REV,   TRUE)  ;
    SetFocus (GetDlgItem (hwnd, IDC_PLAY_BEG)) ;
	bPlaying =FALSE;
}

void SetRecordingModeButton(HWND hwnd)
{
          MainWinButton( IDC_RECORD_BEG, FALSE) ;
          MainWinButton( IDC_RECORD_END, TRUE)  ;
          MainWinButton( IDC_PLAY_BEG,   FALSE) ;
          MainWinButton( IDC_PLAY_PAUSE, FALSE) ;
          MainWinButton( IDC_PLAY_END,   FALSE) ;
     //     MainWinButton( IDC_PLAY_REV,   FALSE) ;
          MainWinButton( IDC_PLAY_REP,   FALSE) ;
    //      MainWinButton( IDC_PLAY_SPEED, FALSE) ;
          MainWinButton( IDC_FILE_NAME, FALSE) ;
}

void SetPlayModeButton(HWND hwnd)
{
			MainWinButton( IDC_BUFF_DOWN, FALSE) ;
			MainWinButton( IDC_BUFF_1, FALSE) ;
			MainWinButton( IDC_BUFF_UP, FALSE) ;
			MainWinButton( IDC_RECORD_BEG, FALSE) ;
			MainWinButton( IDC_RECORD_END, FALSE) ;
			MainWinButton( IDC_PLAY_BEG,   FALSE) ;
			MainWinButton( IDC_PLAY_PAUSE, TRUE)  ;
			MainWinButton( IDC_PLAY_END,   TRUE)  ;
			MainWinButton( IDC_PLAY_REP,   TRUE) ;
	//		MainWinButton( IDC_PLAY_REV,   FALSE) ;
	//		MainWinButton( IDC_PLAY_SPEED, FALSE) ;
			MainWinButton( IDC_FILE_NAME, TRUE) ;
          SetFocus (GetDlgItem (hwnd, IDC_PLAY_END)) ;
}


void gettextdata(HWND hwnd,int id, long &data)
{
	char buffer[1000];
	long buff;
	GetWindowText(GetDlgItem(hwnd,id),buffer,GetWindowTextLength(GetDlgItem(hwnd,id))+1);
	sscanf(buffer,"%d",&buff);
	data=buff;
	settext(id,data,"");
	//ShowError(buffer);
}

void gettextdata(int id, long &data)
{
	gettextdata(mainhwnd, id, data);
}
void gettexts()
{
	gettextdata(IDC_EDIT_CHANNEL,(long&)channels);
	gettextdata(IDC_EDIT_SamplesPerSec,rate);
	gettextdata(IDC_EDIT_BitsPerSample,(long&)samplesize);
}


void settext(HWND hwnd,int id, long value,char *after)
{
	char buff[MAX_PATH];
	sprintf(buff,"%d%s",value,after);
	SetDlgItemText(hwnd,id,buff);
}

void settext(int id,unsigned long value,char *after)
{
	settext(mainhwnd,id,value,after);
}


void setcomment(int id,char *after)
{
	char buff[MAX_PATH];
	sprintf(buff,"%s",after);
	SetDlgItemText(mainhwnd,id,buff);
}

void setcomment(int id,int v)
{
	char buff[MAX_PATH];
	sprintf(buff,"%d",v);
	SetDlgItemText(mainhwnd,id,buff);
}


void settexttime(HWND hwnd,int id,unsigned long value,unsigned long BPSstep)
{
	//int	hour,min,sec;hour,
	int	min;
	double sec;
	char buff[MAX_PATH];
//	hour=value/3600;
//	min=(value-hour*60)/60;
	min=value/BPSstep/60;
	sec=(value-min*60*BPSstep)*1.0/BPSstep;
	//sprintf(buff,"%02d:%02d:%02d",hour,min,sec);
	sprintf(buff,"%04d:%06.3f",min,sec);
	SetDlgItemText(hwnd,id,buff);
}

void settexttime(int id,unsigned long value,unsigned long BPSstep)
{
	settexttime(mainhwnd,id,value,BPSstep);
}


void settexts(WAVEFORMATEX *wf)
{
	setvolume(levelp);
	settext(IDC_EDIT_CHANNEL,channels,"");
	settext(IDC_EDIT_RATE,rate,"");
	settext(IDC_EDIT_BIT,samplesize,"");
	settext(IDC_EDIT_BUFF,membuffersize,"");
	settext(IDC_EDIT_datasize,datasize,"");
	  
//	settexttime(IDC_EDIT_time,dwTimenow,);
	settext(IDC_EDIT_formattag,format,"");	
	settext(IDC_EDIT_channels,channels,"");	
	settext(IDC_EDIT_BitsPerSample,samplesize,"");	
	settext(IDC_EDIT_SamplesPerSec,rate,"");
	if(wf==NULL) return;
	settext(IDC_EDIT_SamplesPerSec,wf->nSamplesPerSec,"");	
	settext(IDC_EDIT_BytesPerSec,wf->nAvgBytesPerSec,"");	
	settext(IDC_EDIT_block,wf->nBlockAlign,"");		
}

void setglaf(char *wavenow)
{
		 int j=volume100/2;
		 strcpy(wavenow,glaf0);
		 strncpy(wavenow,glaf,j);
}

void ShowError(char *szError)
{
	MessageBeep (MB_ICONEXCLAMATION) ;
	MessageBox (mainhwnd, szError, szAppName,
				MB_ICONEXCLAMATION | MB_OK) ;
}


//...........................................
// Cobt@AĐJnʒuZbg


void setpositionnow(ifstream *in)
{
	if(!in->seekg(positionnow +datapos(),ios::beg))//in->eof()
	{
		in->clear();
		in->close();
		in->open(filename,ios::binary | ios::nocreate);
		positionnow=0;
		in->seekg(positionnow +datapos(),ios::beg);
	}
}


void resetrecordedsize()
{
	recordedsize=0;
}


void setsamplesize(HWND hwnd, int bit)
{
	samplesize =bit;
	settexts();
	settext(IDC_EDIT_BIT,samplesize,"");
	SendMessage (hwnd, WM_COMMAND, IDC_RECORD_RESET, 0) ;
}

void rateupdown()
{
	rate=ratebase*raterate;
	settext(IDC_EDIT_RATE,rate,"");
	settext(IDC_EDIT_RATE2,rate,"");
	settexts(NULL);
	SendMessage (mainhwnd, WM_COMMAND, IDC_PLAY_restart_if, 0) ;
}

void setchannels(int st)
{
	channels =st;
	settext(IDC_EDIT_CHANNEL,channels,"");
}

void showall()
{
	readallsoundpic(pSkipBuffer, filename,datasize/(wavelpicxl/4*2)+8);
	pWavepicBuffer =pSkipBuffer;
	ShowWave();
}

BOOL buffmain(WORD id)
{
	switch (id)
	{
          case IDC_BUFF_1:
			  resetmembuffersize();
				settext(IDC_EDIT_BUFF,membuffersize,"");
              return TRUE ;

          case IDC_BUFF_UP:
			  upmembuffersize();
				settext(IDC_EDIT_BUFF,membuffersize,"");
              return TRUE ;

          case IDC_BUFF_DOWN:
			  downmembuffersize();
				settext(IDC_EDIT_BUFF,membuffersize,"");
              return TRUE ;
	}
	return TRUE;
}


BOOL recmain(WORD id, ifstream *in, HWAVEIN &hWaveIn, PWAVEHDR *pWaveHdr, DWORD &len, WAVEFORMATEX &waveform, ofstream &ou)
{
	int i;
	switch (id)
	{
          case IDC_RECORD_RESET:
			  recordresetbutton(mainhwnd);
				ou.close();
              setwaveformRec(waveform,format,channels,rate,samplesize);
			 // saveall(waveform,backname);
			  datasize=0;
				ou.open(buffname,ios::binary|ios::trunc|ios::ate);
				return TRUE ;

		  case IDC_REC_FOREVER:
			  looprecflag=TRUE;
               
			  //^obt@irealplayerĐƓ^AJnƓɃnOAbv̂ŃeXgj
		  case IDC_REC_BUFF_STANDBY:
			  if(!levelcheckflag)
			  {
				  setmembuffersize();
				  readsize =membuffersize;
					for(i=0;i< bufferNum;i++)
					{
						free(pBuffer[i]);
						pBuffer[i] = (PBYTE)malloc (membuffersize) ;
					}
					if(!errorcheck(mainhwnd,pBuffer))
					{
						RecStandBy=TRUE;
						Comment("standby");
					}
			  }
			  return TRUE;

          case IDC_RECORD_BEG:
			  gettexts();
			  resetrecordedsize();
			  recbuffnum =0;
			  if(levelcheckflag)
			  {
			  }
			  else
			  {
				  in->close();
				  setmembuffersize();
			  }
			  readsize =membuffersize;
			Comment("recording");
			writefilename(filename,initialfile);
			if(looprecflag) Comment("loop recording");
			if(levelcheckflag) Comment("level check");
			  recordresetbutton(mainhwnd);
                    // Allocate buffer memory

			if(!RecStandBy) for(i=0;i< bufferNum;i++)
			{
				free(pBuffer[i]);
				pBuffer[i] = (PBYTE)malloc (membuffersize) ;
			}
               
			   if(errorcheck(mainhwnd,pBuffer))return TRUE;
			   LockBitButton(mainhwnd);
               
                    // Open waveform audio for input
			   playsamplesize=samplesize;
               setwaveformRec(waveform,format,channels,rate,samplesize);
               
               if (waveInOpen (&hWaveIn, WAVE_MAPPER, &waveform, 
                               (DWORD) mainhwnd, 0, CALLBACK_WINDOW))
               {
					for(int i=0;i<bufferNum;i++)free (pBuffer[i]) ;
					ShowError(szOpenError);
               }
                    // Set up headers and prepare them
				for(i=0;i<bufferNum;i++)
				{
					SetWaveHdr(pWaveHdr[i],pBuffer[i],membuffersize,0,1);
					waveInPrepareHeader (hWaveIn, pWaveHdr[i], sizeof (WAVEHDR)) ;
				}

               return TRUE ;

               
          case IDC_RECORD_END:
			  looprecflag=FALSE;
			  RecStandBy=FALSE;
			Comment("rec.end");
                    // Reset input to return last buffer
               
               bEnding = TRUE ;
			   positionnow=0;
			   bRecordingPaused = FALSE ;
               waveInReset (hWaveIn) ;
               return TRUE ;
               
          case IDC_RECORD_PAUSE:
			Comment("rec.pause");
                    // Reset input to return last buffer
               
               bEnding = TRUE ;
			   bRecordingPaused = TRUE ;
               waveInReset (hWaveIn) ;
			   len =membuffersize;
			   //dwDataLength=loadwave (pBuffer1, dwDataLength,&waveform) ;
               return TRUE ;
	}
	return TRUE;
}