
//---------------------------------------------------------
//	dialog 

#include "defextern.h"

#include <stdio.h>
//#include <iostream.h>
//#include <fstream.h>
#include <windows.h>

#include "resource.h"
#include "tabasa_recorder.h"
#include "SubSoundSetting.h"
#include "MainDlg.h"

#include "scroll.h"

#define SubTime( t,d ) 	settexttime(hwnd,IDC_SUB_time,(t),(d))	
const char DlgTitle[]="sub sound setting";
HWND hwndSubSoundVol, hwndSubSoundPan;
/*
static int mode;
#define _PLAY 0
#define _STOP 1
#define _OPEN 2
int modemax=2;
*/

BOOL CALLBACK SubSoundSettingProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static int nownum,n;
	static POINT subsoundvolumep={45,50};
	static POINT subsoundpanp={subsoundvolumep.x,subsoundvolumep.y+70};
	char buff[10];
	static float level;
	WORD num;
     switch (message)
     {
		case WM_INITDIALOG:
			SubSoundSettingHwnd=hwnd;
			SetWindowText(hwnd,DlgTitle);
			nownum=0;
			panscrollinit(hwnd,hwndSubSoundPan,subsoundpanp,ef[nownum].getPan(),panmax);
			boostscrollinit(hwnd,hwndSubSoundVol,subsoundvolumep,ef[nownum].getboost());
			SendMessage (hwnd, WM_COMMAND, IDC_SHOW_SUB_NUM, 0L) ;
			//mode=_PLAY;
			break;

     case WM_HSCROLL :
		if((HWND) lParam==hwndSubSoundVol)
		{
			boostscrollfnc( wParam,ef[nownum].getboost(),levelmax);
          //
			setboost(hwnd,hwndSubSoundVol,IDC_SUB_boost,ef[nownum].getboost());
		}
		if((HWND) lParam==hwndSubSoundPan)
		{
			panscrollfnc( wParam,ef[nownum].getPan(),-panmax,panmax);
          //
			setPan(hwnd,hwndSubSoundPan,IDC_SUB_Pan,ef[nownum].getPan());
		}
		break;

     case WM_COMMAND:
          switch (LOWORD (wParam))
          {
		  case IDC_SUB_NUM_MINUS:
			  nownum-=2;
		  case IDC_SUB_NUM_PLUS:
			  nownum++;
		  case IDC_SHOW_SUB_NUM:
			  if(nownum>=effectfilemax || nownum<0) nownum=0;
			  if(ef[nownum].getrecorded()) sprintf(buff,"");
			  else sprintf(buff,"Ȃ");
			SetDlgItemText(hwnd,IDC_SUB_recorded,buff);
			SetDlgItemInt(hwnd,IDC_SUB_position,ef[nownum].getposition(),FALSE);
			SetDlgItemInt(hwnd,IDC_SUB_NUM,nownum+1,FALSE);
			SetDlgItemText(hwnd,IDC_SUB_NAME,ef[nownum].getName());
			
			SubTime(ef[nownum].getpositionnow(),BPSstep);
			setboost(hwnd,hwndSubSoundVol,IDC_SUB_boost,ef[nownum].getboost());
			setPan(hwnd,hwndSubSoundPan,IDC_SUB_Pan,ef[nownum].getPan());
			  break;

		  case IDC_SUB_NUM_SET:
			  nownum=GetDlgItemInt(hwnd,IDC_SUB_NUM,NULL,FALSE)-1;
				SendMessage (hwnd, WM_COMMAND, IDC_SHOW_SUB_NUM, 0L) ;
			  break;

		  case IDC_PLAY_SUB_levelreset:
			  break;

          case IDOK:
          case IDCANCEL:
               SendMessage (hwnd, WM_SYSCOMMAND, SC_CLOSE, 0L) ;
               return TRUE ;


		  }
		  break;

		case WM_SYSCOMMAND:
			switch (LOWORD (wParam))
			{
				case SC_CLOSE:
					EndDialog (hwnd, 0) ;
					SubSoundSettingHwnd=NULL;
				return TRUE ;
			}
			break ;
          
	}
	 return FALSE;
}
