
#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>


#include "resource.h"
#include "tabasa_recorder.h"
#include "position.h"
#include "scroll.h"
#include "wavepic.h"
#include "MainDlg.h"
#include "SoundBuffer.h"

const char PositionDialogName[]="POSITION_COMMENT";
static ULONG num;
HWND poshwnd;
ULONG posnow;
#define buffsize 300
char buff[buffsize];
char comment[buffsize];

BOOL CALLBACK PositionProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static char buff[buffsize];
	static int nownum,auxNum,waveinNum;
     switch (message)
     {
		case WM_INITDIALOG:
			  sprintf(buff,"%d",posnow);
			  SetDlgItemText(hwnd,IDC_POSITION_VALUE,buff);
			  sprintf(buff,"%s",comment);
			  SetDlgItemText(hwnd,IDC_POSITION_EDIT,buff);
			break;

     case WM_HSCROLL :
		  break;

     case WM_COMMAND:
          switch (LOWORD (wParam))
          {//
          case IDOK:
			  GetDlgItemText(hwnd,IDC_POSITION_EDIT,buff,buffsize);
			  sprintf(comment,"%s",buff);
               SendMessage (hwnd, WM_SYSCOMMAND, SC_CLOSE, 0L) ;
               return TRUE ;

          case IDCANCEL:
               SendMessage (hwnd, WM_SYSCOMMAND, SC_CLOSE, 0L) ;
               break ;


		  }
		  break;

		case WM_SYSCOMMAND:
			switch (LOWORD (wParam))
			{
				case SC_CLOSE:
					EndDialog (hwnd, 0) ;
				return TRUE ;
			}
			break ;
          
	}
	 return FALSE;
}

void setcomment()
{
	sprintf(buff,"%d>%s",num,comment);
	SetWindowText(poshwnd,buff);
}

void initpositionfile()
{
	strcpy(positionfile,"position.txt");
	resetpositionnum();
}

void setpositionhwnd(HWND hwnd)
{
	poshwnd = hwnd;
}

void saveposition(ULONG pos)
{
	posnow=pos;
	DialogBox (hInstance,PositionDialogName,mainhwnd, (int (__stdcall *)(void))PositionProc);

	ofstream ou(positionfile,ios::ate);
	ou<<pos<<','<<comment<<endl;
}

//.........................
// position.txt J

void editpositionfile()
{
	sprintf(buff,"notepad %s",positionfile);
	WinExec(buff,SW_SHOW);
}


void loadposition()
{
	loadposition(posnow,num);
}

void loadposition(ULONG &pos)
{
	loadposition(pos,num);
}

void resetcomment()
{
	comment[0]='\0';
}


void loadposition(ULONG &pos,ULONG &num)
{
	resetcomment();
	ifstream in(positionfile,ios::nocreate);
	if(!in || num==0) 
	{
		num=0;
		pos=0;
	}
	for(ULONG i=0;i<num;i++) 
	{
		in.getline(buff,buffsize);
		resetcomment();
		if(in.gcount()==0)
		{
			num=0;
			pos=0;
			break;
		}
		sscanf(buff,"%lu,%s",&pos,comment);
		//in.get(buff[0]);
		/*in>>pos;
		if (in.eof()) 
		{
			num=0;
			pos=0;
		}
		*/
	}
	//posnow=pos;
	setcomment();
}



void loadnextposition(ULONG &pos,int i)
{
	if (num==0 && i<0) return;
	num+=i;
	loadposition(pos,num);
}


void resetpositionnum()
{
	num=0;
	loadposition();
}

void setpositionnum(int i)
{
	if (i>=0) 
	{
		num =i;
		loadposition();
	}
}

void positionnumplus(int i)
{
	num +=i;
	loadposition();
}

BOOL DlgPositionMain(WORD id, ifstream *in)
{
	switch (id)
	{
          case IDC_edit_posfile:
			  editpositionfile();
               break;

          case IDC_save_pos:
			  saveposition(positionnow);
               break;

          case IDC_load_pos:
			  if(!bPlaying)
			  {
					loadnextposition(positionnow);
					scrollnow=(float)positionnow/datasize*scrollmax;
					SetScrollPos  (hwndScroll, SB_CTL, scrollnow, TRUE) ;
					resetsoundpic();
					Time(positionnow,BPSstep);
					setpositionnow(in);
					pWavepicBuffer =pSkipBuffer;
					ShowWave();
			  }
			  else positionnumplus(1);
               break;

          case IDC_load_pos_back:
			  if(!bPlaying)
			  {
			  loadnextposition(positionnow,-1);
			//positionnow=datasize/scrollmax*scrollnow/4*4;
			scrollnow=(float)positionnow/datasize*scrollmax;
			SetScrollPos  (hwndScroll, SB_CTL, scrollnow, TRUE) ;
			resetsoundpic();
			Time(positionnow,BPSstep);
			setpositionnow(in);
			pWavepicBuffer =pSkipBuffer;
			ShowWave();
			  }
			  else positionnumplus(-1);
               break;

          case IDC_load_pos_0:
			  if(!bPlaying)
			  {
			  resetpositionnum();
			  positionnow=0;
			scrollnow=0;
			SetScrollPos  (hwndScroll, SB_CTL, scrollnow, TRUE) ;
			resetsoundpic();
			Time(positionnow,BPSstep);
			setpositionnow(in);
			pWavepicBuffer =pSkipBuffer;
			ShowWave();
			  }
			  else setpositionnum(0);
			  break;

          case IDC_load_pos_now:
			loadposition(positionnow);
			scrollnow=(float)positionnow/datasize*scrollmax;
			SetScrollPos  (hwndScroll, SB_CTL, scrollnow, TRUE) ;
			resetsoundpic();
			Time(positionnow,BPSstep);
			setpositionnow(in);
			pWavepicBuffer =pSkipBuffer;
			ShowWave();
			  break;
	}
	return TRUE;
}